package com.malk.kaiyue_nt.service;

import com.malk.server.common.McR;
import org.springframework.scheduling.annotation.Async;

import java.util.List;
import java.util.Map;

public interface KYNTService {
    /**
     * 获取员工花名册信息
     * @param map
     * @return
     */
    List<Map> getEmployeeRosterInfo(Map<String, Object> map);

    /**
     * 获取在职员工userId列表
     * @return
     */
    List<String> getEmployeeUserId();

    /**
     * 计算并设置获取员工年假数
     * @param map
     * @return
     */
    @Async
    McR getEmployeeAnnualLeaveNum(Map<String, Object> map);

    /**
     * 每年1月1日 01:00定时更新员工年假数
     * @return
     */
    McR updateEmployeeAnnualLeaveNum();

    Map getUserLeaveInfo(String userId);
}
