package com.malk.zhixingtongde.controller;

import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSONObject;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.common.McR;
import com.malk.server.common.McREnum;
import com.malk.service.aliwork.YDClient;
import com.malk.utils.UtilMap;
import com.malk.zhixingtongde.entity.Profit;
import com.malk.zhixingtongde.service.ZxtdReportService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.File;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@CrossOrigin
@Slf4j
@RequestMapping("/report")
public class ZxtdReportConroller {

    @Autowired
    private ZxtdReportService zxtdReportService;

    @GetMapping("/test")
    public McR test(){
        log.info("test");
        return McR.success();
    }

    @GetMapping("/exportProfit")
    public void exportProfit(HttpServletResponse response,String year){
        zxtdReportService.exportProfit(response,year);
    }

    //导出季度核算表
    @GetMapping("/exportQuarterProfit")
    public void exportQuarterProfit(HttpServletResponse response,String year){
        zxtdReportService.exportQuarterProfit(response,year);
    }

    //导出应收账款明细表
    @GetMapping("/exportReceivableDetails")
    public void exportReceivableDetails(HttpServletResponse response,String year){
        zxtdReportService.exportReceivableDetails(response,year);
    }

    //导出其他应收款明细表
    @GetMapping("/exportOtherReceivableDetails")
    public void exportOtherReceivableDetails(HttpServletResponse response,String year){
        zxtdReportService.exportOtherReceivableDetails(response,year);
    }

    //导出应付账款明细表
    @GetMapping("/exportPayableDetails")
    public void exportPayableDetails(HttpServletResponse response,String year){
        zxtdReportService.exportPayableDetails(response,year);
    }

    //导出其他应付款明细表
    @GetMapping("/exportOtherPayableDetails")
    public void exportOtherPayableDetails(HttpServletResponse response,String year){
        zxtdReportService.exportOtherPayableDetails(response,year);
    }

    //导出资产负债表
    @GetMapping("/exportLiabilitiesDetails")
    public void exportBalanceSheet(HttpServletResponse response,String year){
        zxtdReportService.exportLiabilitiesDetails(response,year);
    }

    //导出所有表（利润表、季度利润表、应收账款表、其他应收款表、应付账款表、其他应付款表）
    @GetMapping("/exportAll")
    public void exportAll(HttpServletResponse response,String year){
        zxtdReportService.exportAll(response,year);
    }

    //导出现金流量主表及附表
    @GetMapping("/exportCash")
    public void exportCash(HttpServletResponse response,String year) {
        zxtdReportService.exportCash(response, year);
    }

    //上传文件至钉盘
    @PostMapping("/uploadToDingTalk")
    public McR uploadToDingTalk(HttpServletResponse response,String userId) {
        try {
            zxtdReportService.uploadToDingTalk(response,userId);
        }catch (Exception e){
            return McR.error(McREnum.UNKNOWN_EXCEPTION.toString(),"上传文件至钉盘失败");
        }

        return McR.success();
    }

    //现金流量表上传文件至钉盘
    @PostMapping("/uploadToDingTalk2")
    public McR uploadToDingTalk(HttpServletResponse response,String userId,String month) {
        try {
            zxtdReportService.uploadToDingTalk2(response,userId,month);
            System.out.println("");
        }catch (Exception e){
            return McR.error(McREnum.UNKNOWN_EXCEPTION.toString(),"上传文件至钉盘失败");
        }

        return McR.success();
    }

    @GetMapping("/updateTest")
    public McR updateTest() {
        zxtdReportService.updateTest();
        return McR.success();
    }


}
