package com.malk.zhixingtongde.service;

import org.springframework.scheduling.annotation.Async;

import javax.servlet.http.HttpServletResponse;

public interface ZxtdReportService {

    void exportProfit(HttpServletResponse response,String year);

    /**
     * 导出季度核算表
     * @param response
     * @param year
     */
    void exportQuarterProfit(HttpServletResponse response, String year);

    /**
     * 导出应收账款明细表
     * @param response
     * @param year
     */
    void exportReceivableDetails(HttpServletResponse response, String year);

    /**
     * 导出其他应收款明细表
     * @param response
     * @param year
     */
    void exportOtherReceivableDetails(HttpServletResponse response, String year);

    /**
     * 导出其他应付款明细表
     * @param response
     * @param year
     */
    void exportOtherPayableDetails(HttpServletResponse response, String year);

    /**
     * 导出所有表（利润表、季度利润表、应收账款表、其他应收款表、其他应付款表）
     * @param response
     * @param year
     */
    void exportAll(HttpServletResponse response, String year);

    /**
     * 导出现金流量主表及附表
     * @param response
     * @param year
     */
    void exportCash(HttpServletResponse response, String year);

    /**
     * 上传文件至钉盘
     * @param response
     * @param userId
     */
    @Async
    void uploadToDingTalk(HttpServletResponse response,String userId);

    /**
     * 导出应付账款明细表
     * @param response
     * @param year
     */
    void exportPayableDetails(HttpServletResponse response, String year);

    /**
     * 导出资产负债表
     * @param response
     * @param year
     */
    void exportLiabilitiesDetails(HttpServletResponse response, String year);

    /**
     * 现金流量表上传文件至钉盘
     * @param response
     * @param userId
     * @param month
     */
    void uploadToDingTalk2(HttpServletResponse response, String userId, String month);

    void updateTest();

}
